#include <windows.h>

#define APP_NAME TEXT("Sample_MainWindow")
#define BMPFILE TEXT("imouto.bmp")
/*
Ă̂ƂgĂ̂windows.ĥ݂ł
EChEYvOƂċNĉ摜\邾̂̂ł
exeƓtH_ɂimouto.bmp\܂
ŏIIɃEChEYvOƂčȂwinmainō郁Cł͂Ȃ
܂̉ɕʂ̃TuEChĂɕ\ĂƂɂȂ܂H
flӌł畷Ăł
*/

LRESULT CALLBACK WindowProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	static HDC hMemDC;
	static HBITMAP hBitmap;
	static BITMAP bitmap;

	switch(uMsg)
	{
	case WM_DESTROY:
		DeleteDC(hMemDC);
		DeleteObject(hBitmap);

		PostQuitMessage(0);
		return 0;

	case WM_CREATE:
		hMemDC=CreateCompatibleDC(NULL);
		hBitmap = (HBITMAP)LoadImage((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),BMPFILE,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
		SelectObject(hMemDC,hBitmap);
		GetObject(hBitmap,sizeof(BITMAP),&bitmap);
		return 0;

	case WM_PAINT:
		hdc=BeginPaint(hWnd,&ps);
		BitBlt(hdc,0,0,bitmap.bmWidth,bitmap.bmHeight,hMemDC,0,0,SRCCOPY);
		EndPaint(hWnd,&ps);

		return 0;

	case WM_KEYUP:
		if(wParam==VK_ESCAPE)DestroyWindow(hWnd);
		return 0;
	case  WM_NCHITTEST:
		return HTCAPTION;

	}
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

/*
牺͂悭Tv̂܂܂ł
ŃECh̑傫܂Ăŉ摜̑傫ɂ炸ɂȂƎv܂
*/

int WINAPI WinMain(HINSTANCE hInstance,
				   HINSTANCE hPrevInstance,PSTR lpCmdLine,int nCmdShow)
{
	WNDCLASS wc;
	MSG msg;

	wc.style=CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc=WindowProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInstance;
	wc.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName=NULL;
	wc.lpszClassName=APP_NAME;

	if(!RegisterClass(&wc))return 0;

	if(CreateWindow(APP_NAME,
		TEXT(__FILE__),
		WS_POPUP | WS_VISIBLE,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		500,500,NULL,NULL,hInstance,NULL)==NULL)return 0;
	while(GetMessage(&msg,NULL,0,0)>0)
	{
		DispatchMessage(&msg);
	}
	return msg.wParam;
}